

# variable started 0


if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    
    set BufferRxIndex 1
    set FullIndex 42

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable NUMlinks 32
    variable statsBlocks [list 0]
    for {set i 1} {$i <= $NUMlinks} {incr i} {lappend statsBlocks $i}
    variable statsBlock [first $statsBlocks]

    variable allblocks 0
    variable SelectedItem 1
    variable AutoUpdate 0

	variable BaseRate 0
	variable BaseTotal 0

	variable LastTime [ clock seconds ]
	variable LinkRate
    for {set i 0 } {$i <= $NUMlinks} {incr i} { set LinkRate($i) 0 }
	variable LinkIP
    for {set i 0 } {$i <= $NUMlinks} {incr i} { set LinkIP($i) 0 }
	variable LastTotal
    for {set i 0 } {$i <= $NUMlinks} {incr i} { set LastTotal($i) 0 }
	variable LinkPercent
    for {set i 0 } {$i <= $NUMlinks} {incr i} { set LinkPercent($i) 0 }
	variable LinkFull
    for {set i 0 } {$i <= $NUMlinks} {incr i} { set LinkFull($i) 0 }
	variable LinkFull_Text
    for {set i 0 } {$i <= $NUMlinks} {incr i} { set LinkFull_Text($i) "" }


    variable JS ""

    variable NUM 64
    for {set i 0} {$i <= $NUM} {incr i} {
      if {![info exists ITEM($i)]} {set ITEM($i) ""}
    }


     variable Stats
     variable Rates

   proc  show_variables {} {
       variable allblocks
       variable AutoUpdate
       variable SelectedItem
       variable statsBlock
	variable BaseRate 

       InsertLog "allblocks=$allblocks; autoupdate=$AutoUpdate; stats block=$statsBlock; selecteditem=$SelectedItem ; BaseRate = $BaseRate"
   }

    proc do_update {Block} {
        variable NUM
	variable BufferRxIndex
	variable FullIndex
        variable Stats
        variable Rates
	variable BaseRate
	variable BaseTotal
	variable LinkRate
	variable LinkPercent
	variable LastTotal
	variable LinkFull
	variable LinkFull_Text
	variable LinkIP

	set NLinks $::MERGE::NLinks

       	set data [ReadNetVar NetVar.MRGE.Rates0]
	set val [expr [lindex $data [expr $BufferRxIndex*2]]]
	set BaseRate $val

       	set data [ReadNetVar NetVar.MRGE.Stats0]
	set val [expr [lindex $data [expr $BufferRxIndex*2]]]
	set BaseTotal $val

	for { set link 0 } { $link < $NLinks } { incr link } {
		if { [ set ::MERGE::LinkInUse($link) ] == 1 } {
			set block [ expr $link + 1 ]
			set port [ ReadNetVar NetVar.Merge.Link$link.Port ]
			set result [ catch { exec  netstat -anp | grep :$port | grep ESTABLISHED } ipAddress ]
			set ipIndex [ string first 193 $ipAddress 26 ]
			set ipcolon [ string first : $ipAddress $ipIndex ] 
			set LinkIP($link) [ string range $ipAddress $ipIndex [ expr $ipcolon - 1 ] ]

       			set data [ReadNetVar NetVar.MRGE.Rates$block]
			set val [expr [lindex $data [expr $BufferRxIndex*2]]]
			set LinkRate($link) $val
			if { $BaseRate == 0 } {
				set LinkPercent($link) 0
			} else {
				set LinkPercent($link) [ expr ( 100 * [ set LinkRate($link) ] ) /$BaseRate ]
			}

       			set data [ReadNetVar NetVar.MRGE.Stats$block]
			set val [expr [lindex $data [expr $BufferRxIndex*2]]]
			set LastTotal($link) $val

			set val [expr [lindex $data [expr $FullIndex*2]]]
			if { $val == [ set LinkFull($link) ] } {
				set LinkFull_Text($link) "<font color=blue>$val</font>"
			} else {
				set LinkFull_Text($link) "<font color=red>$val</font>"
			}
			set LinkFull($link) $val


		}
       }

   }   

    proc do_GetCounters {{block 0}} {
       variable NUM
       variable Stats

#   puts "do_GetCounters:"

       do_update $block

       set rc ""
       for {set i 0} {$i < $NUM} {incr i} {append rc "[set Stats($i)] "}

       return $rc
    }

    proc do_GetRates {{block 0}} {
       variable NUM
       variable Rates

#   puts "do_GetRates:"

       do_update $block

       set rc ""
       for {set i 0} {$i < $NUM} {incr i} {append rc "[set Rates($i)] "}

       return $rc
    }

    proc do_zero {} {

       WriteNetVar NetVar.MRGE.ZeroStats 1
       InsertLog "Statistics Zeroed"
    }

  proc PageNotes {} {InsertLog "Notes in preparation"}

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   NOTES    {PageNotes}

                   UPDATESTATS -
                   UPDATE    { do_update 0 }

                   AUTOUPDATE  {variable AutoUpdate; set AutoUpdate [expr ($AutoUpdate + 1) & 1]}

                   DOZERO    {do_zero}

                   COUNTER   {variable SelectedItem; set SelectedItem $vl}
                   BLOCK      {variable statsBlock; set statsBlock $vl}
                   ALLBLOCKS  {variable allblocks; set allblocks [expr ($allblocks + 1) & 1]}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
       }

    }  ;#  end of do_click

}   ;# end of if {$started == 0}




