

#    support for Web Service access  -  provides application specific support

global MIDAS_DataAcquisitionControlServer_Verbose
set MIDAS_DataAcquisitionControlServer_Verbose 0

puts "loading Html/MERGE/RunControl/implementation.tcl for namespace [namespace current]"

#   include other program files

global env

    set f [file join $env(MIDASBASE) TclHttpd tcl Common runcontrol.tcl]
    set z [catch {source $f} m]
    if {$z != 0} {puts "$f returned z=$z and $m"}

    set f [file join $env(MIDASBASE) TclHttpd Html MERGE RunControl common.tcl]
    set z [catch {source $f} m]
    if {$z != 0} {puts "$f returned z=$z and $m"}

    set f [file join $env(MIDASBASE) TclHttpd Html MERGE RunControl sys.tcl]
    set z [catch {source $f} m]
    if {$z != 0} {puts "$f returned z=$z and $m"}

    set f [file join $env(MIDASBASE) TclHttpd Html MERGE RunControl stats.tcl]
    set z [catch {source $f} m]
    if {$z != 0} {puts "$f returned z=$z and $m"}

    set f [file join $env(MIDASBASE) TclHttpd Html MERGE RunControl stats.defn.tcl]
    if {[file exists $f]} {
#    note that reading this defines the elements of the ITEM array
        set z [catch {source $f} m]
        if {$z != 0} {puts "$f returned z=$z and $m"}
    }

proc do_SetOptionC {} {
   global env
    variable SYS_DataAcquisitionCode
    variable SYS_PrevDataAcquisitionCode
    variable SYS_DataAcquisitionArgs

   set args $SYS_DataAcquisitionArgs

   if {[llength $args] == 1} {set args [first $args]}

   set state [lindex $args 0]
   set opt [lindex $args 1]

   set cmd [first [split $opt =]]
   set vl [second [split $opt =]]

   switch $cmd {
        ClearStats  {
          set z [catch {do_clearstats} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        ParameterSave  {
          set z [catch {ParameterSave $vl} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        ParameterRestore  {
          set z [catch {ParameterRestore $vl} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        OptionSave  {
          set z [catch {SaveOptions} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        OptionRestore  {
          set z [catch {LoadOptions} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        HistogramSave  {
          set z [catch {HistogramSave} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }	
        HistogramZero  {
          set z [catch {HistogramZero} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        SoftwareReload   {
          set f [file join $env(MIDASBASE) TclHttpd tcl MERGERunControl.tcl]
          set z [catch {source $f} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
   
            puts "Project RunControl Implementation reloaded"
        }
        LoadExec  -
        TerminateExec  {
          set z [catch {$cmd} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        DisConnect {
          set z [catch {DataAcqCommand [expr $vl+1] "disconnect data stream $vl" 0 2} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        ReConnect {
          set z [catch {DataAcqCommand [expr ($vl+1)*3] "reconnect data stream $vl" 0 2} m]
          if {$z != 0} {puts "RunControl $cmd returned z=$z and $m"}
        }
        HistEnable  {WriteNetVar NetVar.DACQ.Chistenable $vl}
        XferEnable  {WriteNetVar NetVar.DACQ.Ctxenable $vl}
        Xfer2Enable {WriteNetVar NetVar.DACQ.Ctx2enable $vl}
        default    {puts "SetOption: Unknown Acquisition Option state=$state; opt=\"$opt\"; cmd=$cmd; vl=$vl"}
    }

   set SYS_DataAcquisitionCode $SYS_PrevDataAcquisitionCode
}

proc Appdo_GetOption {args} {   

   if {[llength $args] == 1} {set args [first $args]}

   set state [lindex $args 0]
   set opt [lindex $args 1]

   set cmd [first [split $opt =]]
   set vl [second [split $opt =]]

   set rc "none"

    switch $cmd {
       RawData    {set rc [Dump_Raw_Data]}
       HistEnable {set rc [ReadNetVar NetVar.DACQ.Chistenable]}
       XferEnable {set rc [ReadNetVar NetVar.DACQ.Ctxenable]}
       NetVar     {set rc [ReadNetVar $vl]}
       default    {puts "GetOption: Unknown Acquisition Option state=$state; opt=\"$opt\"; cmd=$cmd"}
    }   

    return "$rc"
}


