

#    MERGE run control 

global MIDAS_DataAcquisitionControlServer_Verbose
set MIDAS_DataAcquisitionControlServer_Verbose 0

global env

global Options

variable MaxTries 20

variable SYS_DataAcquisitionCode  0
variable SYS_PrevDataAcquisitionCode  0
variable SYS_DataAcquisitionArgs 0

variable RunControlDelay1 100
variable RunControlDelay2 50
variable RunControlDelay3 500

variable NLinks 64



#    list of registers required by the UI

variable registerlist

set registerlist {}

lappend registerlist [list NetVar.EXEC.Action                "-n EXEC_Action -t int"]
lappend registerlist [list NetVar.EXEC.Parameter             "-n EXEC_Parameter -t string"]
lappend registerlist [list NetVar.EXEC.ID                    "-n EXEC_ID -t string"]
lappend registerlist [list NetVar.TS_Server                  "-n TS_Server -t string"]
lappend registerlist [list NetVar.TS_Port                    "-n TS_Port -t int"]
lappend registerlist [list NetVar.Xfer_Option                "-n Xfer_Option -t int"]
lappend registerlist [list NetVar.Format_Option              "-n Format_Option -t int"]
lappend registerlist [list NetVar.EB_Server                  "-n EB_Server -t string"]
lappend registerlist [list NetVar.EB_Port                    "-n EB_Port -t int"]
lappend registerlist [list NetVar.EBXfer_Option              "-n EBXfer_Option -t int"]
lappend registerlist [list NetVar.RawDataStorage             "-n RawDataStorage -t string"]

lappend registerlist [list NetVar.EXEC.Response              "-n EXEC_Response -t block -a yes -i 0 -l 444 -f x"]
lappend registerlist [list NetVar.EXEC.PID                   "-n PID_EXEC -t int"]

lappend registerlist [list NetVar.DACQ.CAlive                "-n DACQ_Alive -t int"]
lappend registerlist [list NetVar.DACQ.Ctxenable             "-n DACQ_TxEnable -t int"]
lappend registerlist [list NetVar.DACQ.Cebtxenable           "-n DACQ_EBTxEnable -t int"]
lappend registerlist [list NetVar.DACQ.Crdoutenable          "-n DACQ_RdOutEnable -t int"]
lappend registerlist [list NetVar.DACQ.Chistenable           "-n DACQ_HistEnable -t int"]
lappend registerlist [list NetVar.DACQ.Chistmode             "-n DACQ_HistMode -t int"]
lappend registerlist [list NetVar.DACQ.Cspectramapped        "-n DACQ_SpectraMapped -t int"]
lappend registerlist [list NetVar.DACQ.Ctrace                "-n DACQ_Trace -t int"]

lappend registerlist [list NetVar.DACQ.Sstate                "-n DACQ_State -t int"]
lappend registerlist [list NetVar.DACQ.TestMode              "-n DACQ_TestMode -t int"]
lappend registerlist [list NetVar.DACQ.DebugMode1            "-n DACQ_DebugMode1 -t int"]
lappend registerlist [list NetVar.DACQ.DebugMode2            "-n DACQ_DebugMode2 -t int"]
lappend registerlist [list NetVar.DACQ.DebugMode3            "-n DACQ_DebugMode3 -t int"]
lappend registerlist [list NetVar.DACQ.ReadOutOption         "-n DACQ_ReadOutOption -t int"]
lappend registerlist [list NetVar.DACQ.DelayTicks            "-n DACQ_DelayTicks -t int"]
lappend registerlist [list NetVar.DACQ.PollTicks             "-n DACQ_PollTicks -t int"]
lappend registerlist [list NetVar.DACQ.StatsTime             "-n DACQ_StatsTime -t int"]

lappend registerlist [list NetVar.DACQ.Stats0                "-n DACQ_Stats -t block -a yes -i 0 -l 512 -f d"]
lappend registerlist [list NetVar.DACQ.Rates0                "-n DACQ_Rates -t block -a yes -i 0 -l 512 -f d"]

for {set i 1} {$i <= 24} {incr i} {
    lappend registerlist [list NetVar.DACQ.Stats$i  "-n DACQ_Stats$i -t block -a yes -i 0 -l 512 -f d"]
    lappend registerlist [list NetVar.DACQ.Rates$i  "-n DACQ_Rates$i -t block -a yes -i 0 -l 512 -f d"]
}

lappend registerlist [list NetVar.UseGroup                   "-n DACQ_UseGroup -t int"]

lappend registerlist [list NetVar.DACQ.CPileupRate	  "-n DACQ_PileupRate -t int"]
lappend registerlist [list NetVar.DACQ.InitialTimeStamp	  "-n Merge_InitialTimeStamp -t uint"]
lappend registerlist [list NetVar.DACQ.Spaused            "-n Merge_IsPaused -t int"]
lappend registerlist [list NetVar.DACQ.StatsArray         "-n DACQ_Stats -t int -a yes -i 0 -l 64"]
lappend registerlist [list NetVar.DACQ.RatesArray         "-n DACQ_Rates -t int -a yes -i 0 -l 64"]
lappend registerlist [list NetVar.DACQ.OutputTraces       "-n Merge_OutputTrace -t int"]
lappend registerlist [list NetVar.DACQ.KeepNonMonotonic   "-n Merge_KeepNonMonotonic -t int"]
lappend registerlist [list NetVar.DACQ.StartFromZero      "-n Merge_StartFromZero -t int"]
lappend registerlist [list NetVar.DACQ.DontUseSyncs       "-n Merge_DontUseSyncs -t int"]
lappend registerlist [list NetVar.DACQ.TimeOrderWindow    "-n Merge_TimeOrderWindow -t int"]
lappend registerlist [list NetVar.DACQ.GREATWordOrder     "-n DACQ_GREATWordOrder -t int"]
lappend registerlist [list NetVar.DACQ.SyncBits           "-n Merge_SyncBits -t int"]


#    for the Merge task

lappend registerlist [list NetVar.Merge.Debug             "-n Merge_Debug -t int -f d"]
lappend registerlist [list NetVar.DACQ.Stats.TotalCount   "-n DACQ_Stats -t uint -a yes -i 1 -l 1 -f d"]
lappend registerlist [list NetVar.DACQ.Stats.BuffersInUse "-n DACQ_Stats -t uint -a yes -i 20 -l 1 -f d"]
lappend registerlist [list NetVar.Merge.LinksAvailable    "-n Merge_LinksAvailable -t int -f d"]

lappend registerlist [list NetVar.Merge.EventBuffer        "-n Merge_EventBuffer -t int -f x"]
lappend registerlist [list NetVar.Merge.Output.CurrPointer "-n Merge_EventCurrent -t int -f d"]

for {set link 0} {$link < $NLinks} {incr link} {
    lappend registerlist [list NetVar.Merge.Link$link.InUse  "-n Merge_AspsInUse -t int -a 1 -i $link"]
}

for {set link 0} {$link < $NLinks} {incr link} {
    lappend registerlist [list NetVar.Merge.Link$link.Port   "-n Merge_LinkPort -t int -a 1 -i $link"]
}

for {set link 0} {$link < $NLinks} {incr link} {
    lappend registerlist [list NetVar.Merge.Link$link.Alive  "-n Merge_LinkAlive -t int -a 1 -i $link"]
}
lappend registerlist [list NetVar.Merge.Links.Alive        "-n Merge_LinkAlive -t int -a 1 -i 0 -l $NLinks"]
lappend registerlist [list NetVar.Merge.Links.InUse        "-n Merge_AspsInUse -t int -a 1 -i 0 -l $NLinks"]
lappend registerlist [list NetVar.Merge.Repeat.Alive       "-n Merge_RepeatAlive -t int"]

lappend registerlist [list NetVar.MRGE.dataState       "-n MRGE_data_State -t int"]

#     additional Stats for MERGE

lappend registerlist [list NetVar.MRGE.StatsTime             "-n MRGE_StatsTime -t int"]
lappend registerlist [list NetVar.MRGE.ZeroStats             "-n MRGE_ZeroStats -t int"]

lappend registerlist [list NetVar.MRGE.Stats0                "-n MRGE_Stats -t block -a yes -i 0 -l 512 -f d"]
lappend registerlist [list NetVar.MRGE.Rates0                "-n MRGE_Rates -t block -a yes -i 0 -l 512 -f d"]

for {set i 1} {$i <= $NLinks} {incr i} {
    lappend registerlist [list NetVar.MRGE.Stats$i  "-n MRGE_Stats$i -t block -a yes -i 0 -l 512 -f d"]
    lappend registerlist [list NetVar.MRGE.Rates$i  "-n MRGE_Rates$i -t block -a yes -i 0 -l 512 -f d"]
}


proc Set_Options {} {
   global Options

   LoadOptions

   if {![info exists Options(Rate.channels)]} {set Options(Rate.channels) 1024}
   if {![info exists Options(Stat.channels)]} {set Options(Stat.channels) 1024}
   if {![info exists Options(Stat.shift)]} {set Options(Stat.shift) 0}
   if {![info exists Options(Stat.offset)]} {set Options(Stat.offset) 0}

   if {![info exists Options(Merge.LinksInUse)]} {set Options(Merge.LinksInUse) "1%1%"}

   SaveOptions

}

   proc load_MergeLinks {} {
       global Options
       variable NLinks
       variable LinkInUse

       Set_Options; make-UIregisters

       set configuration [split $Options(Merge.LinksInUse) %]

       for {set link 0} {$link < $NLinks} {incr link} {
          if {$link < [expr [llength $configuration] - 1]} {
             set LinkInUse($link) [lindex $configuration $link]
          } else {
             set LinkInUse($link) 0
          }
       }
   }

   proc store_MergeLinks {} {
       global Options
       variable NLinks
       variable LinkInUse

       Set_Options; make-UIregisters

       set configuration ""

       for {set link 0} {$link < $NLinks} {incr link} {
          append configuration $LinkInUse($link)
          append configuration "%"
       }

       set Options(Merge.LinksInUse) $configuration
       SaveOptions
       
   }

   proc set_MergeLinks {} {
       variable NLinks
       variable LinkInUse

       for {set link 0} {$link < $NLinks} {incr link} {
           WriteNetVar NetVar.Merge.Link$link.InUse $LinkInUse($link)
       }
   }

proc DataAcqState {} {

   set state [expr [ReadNetVar NetVar.DACQ.Sstate] - 1]
   if {$state < 0 || $state > 9} {set state 8}

   return $state
}

proc doSetUp {} {
    variable Options

puts "setup Merge"

    Set_Options; make-UIregisters

    DataAcqCommand 1 "Halt"

    unmap_spectra
    delete_spectra
    create_spectra

    Setup_MergeLinks

    DataAcqCommand 3 "Setup"

    WriteNetVar NetVar.DACQ.PollTicks 100
    WriteNetVar NetVar.DACQ.Crdoutenable 1   ;# enable data readout`
}

proc doReset {} {

puts "reset Merge"

     Set_Options; make-UIregisters

     DataAcqCommand 9 "Reset"
     
     Reset_MergeLinks
}

proc doStop {} {

puts "stop Merge"

     Set_Options; make-UIregisters

     Stop_MergeLinks

     DataAcqCommand 1 "Halt"

     if {[ReadNetVar NetVar.DACQ.Ctxenable] == 1}  {
         DataAcqCommand 1 "disconnect xfer stream" 0 2
     }
}

# command 16 is User Application 1  (Merge_start() in Merge DA code)
# tells the merge DA program to allow data through, starting with timestamp
# equal or greater than the metronome re-synch time
# Should be called after Go_Electronics which has invoked the metronome's
# synchronize-all to set up the initial timestamp value for the cards and
# written it to the merge program

proc doGo {} {

puts "go Merge"

     Set_Options; make-UIregisters

     if {[ReadNetVar NetVar.DACQ.Ctxenable] == 1}  {
         DataAcqCommand 3 "connect xfer stream" 0 2
     }

     DataAcqCommand 2 "Go"

     Go_MergeLinks 

     DataAcqCommand 16 "MergeStart" 0 2

}

# command 17 is User Application 2  (Merge_pause() in Merge DA code)
# This is a toggle.
# if DA is outputting data this tells it to discard data (PAUSE state)
# if DA is discarding data this tells it to restart from the next good
# SYNC pulse or Extended timestamp. Otherwise do nothing.

# proc doPause {v} {

#   set state [ReadNetVar NetVar.DACQ.Spaused]
#   if {$state != $v} {DataAcqCommand 17 "MergePause" 0 2}
# }

proc doPause {} {

   DataAcqCommand 17 "MergePause" 0 2
}

proc doXfer {} {

    set xfer [ReadNetVar NetVar.DACQ.Ctxenable]
    WriteNetVar NetVar.DACQ.Ctxenable [expr ($xfer + 1) & 1]

}

proc Stop_MergeLinks {} {

   set state [ReadNetVar NetVar.DACQ.Spaused]
   if {$state != 1} {DataAcqCommand 17 "MergePause" 0 2}

}

proc DoRestart {args} {

     DataAcqCommand 18 "MergeRestart" 0 2
     UpdateMergeLinks
}

proc Go_MergeLinks {} {

}
 
proc Reset_MergeLinks {} {    ;#   used by RESET

}

proc Setup_MergeLinks {} {    ;#   used by SETUP

    load_MergeLinks
    set_MergeLinks

    WriteNetVar NetVar.DACQ.InitialTimeStamp 0

}

    make-UIregisters

    Set_Options

